#ifdef _PDM_

MANUFACTURER        0x0037,
DEVICE_TYPE         1,
DEVICE_REVISION     0x0300,
DD_REVISION         2

#else

#pragma CW DO_SDK_ANALYSIS 1

MANUFACTURER		YOKOGAWA,
//DEVICE_TYPE		_ROTA,
DEVICE_TYPE		_RAMC,
DEVICE_REVISION 	1,
DD_REVISION		2

#define MAN_ID			55
#define DEF_device_id_PB	"Rotameter RAMC"

#define __DDC__phys_device_man_id_VALUE 0x37                    
#define __DDC__phys_device_id_VALUE { 0x0041, "Rotameter RAMC" }

#include "__DDC__ident_check.ddl"

#endif

#define DD_REV			2

#define CHANNEL1    0x0111  // Volume Flow channel
#define CHANNEL2    0x0115  // Mass Flow channel

//----------------------------------------------------------

#define CERTIFICATE_PNO    "itm 654 PA 01"
#define CERTIFICATE_DEVICE "itm 654 PA 01"

//******************************************************************************
// Defines
//******************************************************************************
#include "ramc_pa_define.ddl"
#define DEVICE_MANUAL_FILENAME      "ramc_pa.hlp"

//******************************************************************************
// Parameters
//******************************************************************************

#include "ramc_pa_pb.ddl"
#include "ramc_pa_tb.ddl"

#define INF_P       (3.40282366920938E+38)
#define INF_N       (-3.40282366920938E+38)
#define DEFAULT_HYS (3.40282366920938E+36)


#define FIND_DEFAULT_VAL(channel)   IF (channel == CHANNEL1) { 100; /* VF m/h */ } \
                                    ELSE { 100; /* MF t/h */  }

#define FIND_UPPER_VAL(channel)     IF (channel == CHANNEL1) { 100.0; /* VF m/h */ } \
                                    ELSE { 100.0; /* MF t/h */  }

#define FIND_LOWER_VAL(channel)     IF (channel == CHANNEL1) { 0.0; /* VF m/h */ } \
                                    ELSE { 0.0; /* MF t/h */ }


#define FIND_DETAIL_UNIT(channel)      IF (channel == CHANNEL1) \
                                        { \
                                            SELECT (trans_volume_flow_unit) \
                                            { \
                                            CASE 1342:  1342; /* % */  \
                                            CASE 1347:  1347; /* 28	m/s       */ \
                                            CASE 1348:  1348; /* 131	m/min     */ \
                                            CASE 1349:  1349; /* 19	m/h       */ \
                                            CASE 1350:  1350; /* 29	m/d       */ \
                                            CASE 1351:  1351; /* 24	l/s        */ \
                                            CASE 1352:  1352; /* 17	l/min      */ \
                                            CASE 1353:  1353; /* 138	l/h        */ \
                                            CASE 1354:  1354; /* 214	l/d        */ \
                                            CASE 1356:  1356; /* 26	ft/s      */ \
                                            CASE 1357:  1357; /* 15	ft/min    */ \
                                            CASE 1358:  1358; /* 130	ft/h      */ \
                                            CASE 1359:  1359; /* 27	ft/d      */ \
                                            CASE 1362:  1362; /* 22	usg/s      */ \
                                            CASE 1363:  1363; /* 16	usg/min    */ \
                                            CASE 1364:  1364; /* 136	usg/h      */ \
                                            CASE 1365:  1365; /* 235	usg/d      */ \
                                            CASE 1367:  1367; /* 137	Impgal/s   */ \
                                            CASE 1368:  1368; /* 18	Impgal/min */ \
                                            CASE 1369:  1369; /* 30	Impgal/h   */ \
                                            CASE 1370:  1370; /* 31	Impgal/d   */ \
                                            CASE 1371:  1371; /* 132	bbl/s      */ \
                                            CASE 1372:  1572; /* 133	bbl/min    */ \
                                            CASE 1373:  1573; /* 134	bbl/h      */ \
                                            CASE 1374:  1374; /* 135	bbl/d      */ \
                                            CASE 1511:  1511; /* 210	cm/s      */ \
                                            CASE 1512:  1512; /* 211	cm/min    */ \
                                            CASE 1513:  1513; /* 212	cm/h      */ \
                                            CASE 1514:  1514; /* 213	cm/d      */ \
                                            CASE 1577:  1577; /* 186	ml/s  XXX  */ \
                                            CASE 1563:  1563; /* 215	ml/min     */ \
                                            CASE 1578:  1578; /* 216	ml/h       */ \
                                            CASE 1633:  1633; /* 221	hl/s       */ \
                                            CASE 1634:  1634; /* 222	hl/min     */ \
                                            CASE 1635:  1635; /* 223	hl/h       */ \
                                            CASE 1636:  1636; /* 224	hl/d       */ \
                                            CASE 1588:  1588; /* 246	Nm/s      */ \
                                            CASE 1589:  1589; /* 241	Nm/min    */ \
                                            CASE 1590:  1590; /* 121	Nm/h      */ \
                                            CASE 1591:  1591; /* 247	Nm/d      */ \
                                            CASE 1592:  1592; /* 248	Nl/s       */ \
                                            CASE 1593:  1593; /* 242	Nl/min     */ \
                                            CASE 1594:  1594; /* 122	Nl/h       */ \
                                            CASE 1595:  1595; /* 249	Nl/d       */ \
                                            CASE 1596:  1596; /* 200	Sm/s      */ \
                                            CASE 1597:  1597; /* 201	Sm/min    */ \
                                            CASE 1598:  1598; /* 202	Sm/h      */ \
                                            CASE 1599:  1599; /* 203	Sm/d      */ \
                                            CASE 1600:  1600; /* 204	Sl/s       */ \
                                            CASE 1601:  1601; /* 205	Sl/min     */ \
                                            CASE 1602:  1602; /* 206	Sl/h       */ \
                                            CASE 1603:  1603; /* 207	Sl/d       */ \
                                            CASE 1604:  1604; /* 208	scf/s      */ \
                                            CASE 1360:  1360; /* 123	scf/min    */ \
                                            CASE 1361:  1361; /* 240	scf/h      */ \
                                            CASE 1605:  1605; /* 209	scf/d      */ \
                                            CASE 1524:  1524; /* 190	sgal/minXXX*/ \
                                            CASE 1525:  1525; /* 191	sgal/h  XXX*/ \
                                            } \
                                        }   /* DO */ \
                                        ELSE \
                                        { \
                                            SELECT (trans_mass_flow_unit) \
                                            { \
                                            CASE 1342:  1342;    /* % */  \
                                            CASE 1526:  1526;    /* 192	mg/s   XXX */ \
                                            CASE 1527:  1527;    /* 193	mg/min XXX */ \
                                            CASE 1528:  1528;    /* 194	mg/h   XXX */ \
                                            CASE 1607:  1607;    /* 187	oz/min XXX */ \
                                            CASE 1608:  1608;    /* 188	oz/h   XXX */ \
                                            CASE 1318:  1318;    /* 70	g/s        */ \
                                            CASE 1319:  1319;    /* 71	g/min      */ \
                                            CASE 1320:  1320;    /* 72	g/h        */ \
                                            CASE 1321:  1321;    /* 218	g/d        */ \
                                            CASE 1322:  1322;    /* 73	kg/s       */ \
                                            CASE 1323:  1323;    /* 74	kg/min     */ \
                                            CASE 1324:  1324;    /* 75	kg/h       */ \
                                            CASE 1325:  1325;    /* 76	kg/d       */ \
                                            CASE 1326:  1326;    /* 217	t/s        */ \
                                            CASE 1327:  1327;    /* 77	t/min      */ \
                                            CASE 1328:  1328;    /* 78	t/h        */ \
                                            CASE 1329:  1329;    /* 79	t/d        */ \
                                            CASE 1330:  1330;    /* 80	lb/s       */ \
                                            CASE 1331:  1331;    /* 81	lb/min     */ \
                                            CASE 1332:  1332;    /* 82	lb/h       */ \
                                            CASE 1333:  1333;    /* 83	lb/d       */ \
                                            CASE 1334:  1334;    /* 219	Ston/s     */ \
                                            CASE 1335:  1335;    /* 84	Ston/min   */ \
                                            CASE 1336:  1336;    /* 85	Ston/h     */ \
                                            CASE 1337:  1337;    /* 86	Ston/d     */ \
                                            CASE 1338:  1338;    /* 220	Lton/s     */ \
                                            CASE 1339:  1339;    /* 243	lton/min   */ \
                                            CASE 1340:  1340;    /* 87	lton/h     */ \
                                            CASE 1341:  1341;    /* 88	Lton/d     */ \
                                            } \
                                        }

#define FIND_DEFAULT_UNIT(channel)      IF (channel == CHANNEL1) \
                                        { \
                                            SELECT (trans_volume_flow_unit) \
                                            { \
                                            CASE 1347:  [unit_1347]; /* 28	m/s       */ \
                                            CASE 1348:  [unit_1348]; /* 131	m/min     */ \
                                            CASE 1349:  [unit_1349]; /* 19	m/h       */ \
                                            CASE 1350:  [unit_1350]; /* 29	m/d       */ \
                                            CASE 1351:  [unit_1351]; /* 24	l/s        */ \
                                            CASE 1352:  [unit_1352]; /* 17	l/min      */ \
                                            CASE 1353:  [unit_1353]; /* 138	l/h        */ \
                                            CASE 1354:  [unit_1354]; /* 214	l/d        */ \
                                            CASE 1356:  [unit_1356]; /* 26	ft/s      */ \
                                            CASE 1357:  [unit_1357]; /* 15	ft/min    */ \
                                            CASE 1358:  [unit_1358]; /* 130	ft/h      */ \
                                            CASE 1359:  [unit_1359]; /* 27	ft/d      */ \
                                            CASE 1362:  [unit_1362]; /* 22	usg/s      */ \
                                            CASE 1363:  [unit_1363]; /* 16	usg/min    */ \
                                            CASE 1364:  [unit_1364]; /* 136	usg/h      */ \
                                            CASE 1365:  [unit_1365]; /* 235	usg/d      */ \
                                            CASE 1367:  [unit_1367]; /* 137	Impgal/s   */ \
                                            CASE 1368:  [unit_1368]; /* 18	Impgal/min */ \
                                            CASE 1369:  [unit_1369]; /* 30	Impgal/h   */ \
                                            CASE 1370:  [unit_1370]; /* 31	Impgal/d   */ \
                                            CASE 1371:  [unit_1371]; /* 132	bbl/s      */ \
                                            CASE 1372:  [unit_1572]; /* 133	bbl/min    */ \
                                            CASE 1373:  [unit_1573]; /* 134	bbl/h      */ \
                                            CASE 1374:  [unit_1374]; /* 135	bbl/d      */ \
                                            CASE 1511:  [unit_1511]; /* 210	cm/s      */ \
                                            CASE 1512:  [unit_1512]; /* 211	cm/min    */ \
                                            CASE 1513:  [unit_1513]; /* 212	cm/h      */ \
                                            CASE 1514:  [unit_1514]; /* 213	cm/d      */ \
                                            CASE 1577:  [unit_1577]; /* 186	ml/s  XXX  */ \
                                            CASE 1563:  [unit_1563]; /* 215	ml/min     */ \
                                            CASE 1578:  [unit_1578]; /* 216	ml/h       */ \
                                            CASE 1633:  [unit_1633]; /* 221	hl/s       */ \
                                            CASE 1634:  [unit_1634]; /* 222	hl/min     */ \
                                            CASE 1635:  [unit_1635]; /* 223	hl/h       */ \
                                            CASE 1636:  [unit_1636y]; /* 224	hl/d       */ \
                                            CASE 1588:  [unit_1588]; /* 246	Nm/s      */ \
                                            CASE 1589:  [unit_1589]; /* 241	Nm/min    */ \
                                            CASE 1590:  [unit_1590]; /* 121	Nm/h      */ \
                                            CASE 1591:  [unit_1591y]; /* 247	Nm/d      */ \
                                            CASE 1592:  [unit_1592]; /* 248	Nl/s       */ \
                                            CASE 1593:  [unit_1593]; /* 242	Nl/min     */ \
                                            CASE 1594:  [unit_1594]; /* 122	Nl/h       */ \
                                            CASE 1595:  [unit_1595y]; /* 249	Nl/d       */ \
                                            CASE 1596:  [unit_1596]; /* 200	Sm/s      */ \
                                            CASE 1597:  [unit_1597y]; /* 201	Sm/min    */ \
                                            CASE 1598:  [unit_1598y]; /* 202	Sm/h      */ \
                                            CASE 1599:  [unit_1599y]; /* 203	Sm/d      */ \
                                            CASE 1600:  [unit_1600]; /* 204	Sl/s       */ \
                                            CASE 1601:  [unit_1601]; /* 205	Sl/min     */ \
                                            CASE 1602:  [unit_1602]; /* 206	Sl/h       */ \
                                            CASE 1603:  [unit_1603]; /* 207	Sl/d       */ \
                                            CASE 1604:  [unit_1604y]; /* 208	scf/s      */ \
                                            CASE 1360:  [unit_1360]; /* 123	scf/min    */ \
                                            CASE 1361:  [unit_1361y]; /* 240	scf/h      */ \
                                            CASE 1605:  [unit_1605y]; /* 209	scf/d      */ \
                                            CASE 1524:  [unit_1524y]; /* 190	sgal/minXXX*/ \
                                            CASE 1525:  [unit_1525y]; /* 191	sgal/h  XXX*/ \
                                            } \
                                        }   /* DO */ \
                                        ELSE \
                                        { \
                                            SELECT (trans_mass_flow_unit) \
                                            { \
                                            CASE 1342:  [unit_1342];	/* % */  \
                                            CASE 1526:  [unit_1526y];    /* 192	mg/s   XXX */ \
                                            CASE 1527:  [unit_1527y];    /* 193	mg/min XXX */ \
                                            CASE 1528:  [unit_1528y];    /* 194	mg/h   XXX */ \
                                            CASE 1607:  [unit_1607y];    /* 187	oz/min XXX */ \
                                            CASE 1608:  [unit_1608y];    /* 188	oz/h   XXX */ \
                                            CASE 1318:  [unit_1318];    /* 70	g/s        */ \
                                            CASE 1319:  [unit_1319];    /* 71	g/min      */ \
                                            CASE 1320:  [unit_1320];    /* 72	g/h        */ \
                                            CASE 1321:  [unit_1321];    /* 218	g/d        */ \
                                            CASE 1322:  [unit_1322];    /* 73	kg/s       */ \
                                            CASE 1323:  [unit_1323];    /* 74	kg/min     */ \
                                            CASE 1324:  [unit_1324];    /* 75	kg/h       */ \
                                            CASE 1325:  [unit_1325];    /* 76	kg/d       */ \
                                            CASE 1326:  [unit_1326];    /* 217	t/s        */ \
                                            CASE 1327:  [unit_1327];    /* 77	t/min      */ \
                                            CASE 1328:  [unit_1328];    /* 78	t/h        */ \
                                            CASE 1329:  [unit_1329];    /* 79	t/d        */ \
                                            CASE 1330:  [unit_1330];    /* 80	lb/s       */ \
                                            CASE 1331:  [unit_1331];    /* 81	lb/min     */ \
                                            CASE 1332:  [unit_1332];    /* 82	lb/h       */ \
                                            CASE 1333:  [unit_1333];    /* 83	lb/d       */ \
                                            CASE 1334:  [unit_1334];    /* 219	Ston/s     */ \
                                            CASE 1335:  [unit_1335];    /* 84	Ston/min   */ \
                                            CASE 1336:  [unit_1336];    /* 85	Ston/h     */ \
                                            CASE 1337:  [unit_1337];    /* 86	Ston/d     */ \
                                            CASE 1338:  [unit_1338];    /* 220	Lton/s     */ \
                                            CASE 1339:  [unit_1339];    /* 243	lton/min   */ \
                                            CASE 1340:  [unit_1340];    /* 87	lton/h     */ \
                                            CASE 1341:  [unit_1341];    /* 88	Lton/d     */ \
                                            } \
                                        }

#define FIND_PV_DISPLAY_FORMAT(channel) IF (channel == CHANNEL1) { ".5f";  /* VF m/h */ } \
                                        ELSE { ".3f";  /* MF t/h */ }




//*********************************************************************
//    Function Block 1: Analog Input
//*********************************************************************

#define DEF_LABEL_FUNC1_AI		"AI Function Block"
#define DISPLAY_FORMAT_FUNC1_AI         DISPLAY_FORMAT  FIXED_DISPLAY_FORMAT(func1_AI_out_decimal_point);
#define DEFAULT_VAL_FUNC1_AI            DEFAULT_VALUE   FIND_DEFAULT_VAL(func1_AI_channel)
#define DEFAULT_UPPER_VAL_FUNC1_AI      DEFAULT_VALUE   FIND_UPPER_VAL(func1_AI_channel)
#define DEFAULT_LOWER_VAL_FUNC1_AI      DEFAULT_VALUE   FIND_LOWER_VAL(func1_AI_channel)
#define DEFAULT_VAL_FUNC1_AI_HYS        DEFAULT_VALUE   DEFAULT_HYS;

#include "ramc_pa_ai1.ddl"


//******************************************************************************
// Menu's
//******************************************************************************

#include "ramc_pa_menu.ddl"

//******************************************************************************
// Table's
//******************************************************************************

#include "ramc_pa_table.ddl"


//******************************************************************************
// Error handling
//******************************************************************************

#include "ramc_pa_err.ddl"