//**********************************************************************
//    Physical Block		(Slot 0)
//**********************************************************************

#define LOCKING_LIST			\
		DEFAULT_VALUE	2457;	\
		{ 2457,	[locking_off]	},\
		{ 0,	[locking_on]	}

BLOCK physical_block
{
	TYPE	PHYSICAL;
    	NUMBER  1;
}

VARIABLE phys_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	1,	[blk_block_object_PHYSICAL]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[phys_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	1,	[phys_blk_parent_class_TRANSMITTER]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_class
{
	LABEL		[blk_class];
	HELP		[phys_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	250;
		{	1,	[standard]		},
		{	250,	[not_used]		}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE phys_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}


VARIABLE dummy_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		LOCAL;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	1;
		{	1,	"1"		}
	}
}

VARIABLE dummy_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		LOCAL;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	1;
		{	1,	"2"		}
	}
}



VARIABLE phys_blk_profile
{
	LABEL		[blk_profile];
	HELP		[blk_profile_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x4002;
		{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
		{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
		{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
		{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0300;
		{	0x0300,	"3.0"	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_execution_time
{
	LABEL		[blk_execution_time];
	HELP		[blk_execution_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE phys_blk_num_parameters
{
	LABEL		[blk_num_parameters];
	HELP		[blk_num_parameters_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_index_view_1
{
	LABEL		[blk_index_view_1];
	HELP		[blk_index_view_1_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
//req18_12	TYPE		ENUMERATED (2);
	HANDLING	READ;
}

VARIABLE phys_blk_num_view_lists
{
	LABEL		[blk_num_view_lists];
	HELP		[blk_num_view_lists_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_st_rev
{
	LABEL		[st_rev];
	HELP		[st_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE phys_tag_desc
{
	LABEL		[tag_desc];
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}

VARIABLE phys_strategy
{
	LABEL		[strategy];
	HELP		[strategy_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_alert_key
{
	LABEL		[alert_key];
	HELP		[alert_key_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_target_mode
{
	LABEL		[target_mode];
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]	},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_actual_mode
{
	LABEL		[actual_mode];
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]	},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE phys_permitted_mode
{
	LABEL		[permitted_mode];
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]		},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE phys_normal_mode
{
	LABEL		[normal_mode];
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]	}
	}
	HANDLING	READ;
}

VARIABLE phys_current_state_alarm_sum
{
	LABEL		[current_state_alarm_sum];
	HELP		[current_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_unacknowledged_state_alarm_sum
{
	LABEL		[unacknowledged_state_alarm_sum];
	HELP		[unacknowledged_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_unreported_state_alarm_sum
{
	LABEL		[unreported_state_alarm_sum];
	HELP		[unreported_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_disabled_state_alarm_sum
{
	LABEL		[disabled_state_alarm_sum];
	HELP		[disabled_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000;
		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_software_rev
{
	LABEL		[phys_software_revision];
	HELP		[phys_software_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

VARIABLE phys_hardware_rev
{
  LABEL		[phys_hardware_revision];
  HELP		[phys_hardware_revision_help];
  CLASS		CONTAINED;
  TYPE		ASCII (16);
  HANDLING	READ;
}

VARIABLE phys_device_man_id
{
  LABEL		[phys_device_man_id];
  HELP		[phys_device_man_id_help];
  CLASS		CONTAINED;
  TYPE		ENUMERATED (2)
  {
    DEFAULT_VALUE	MAN_ID;
    { 55, [Yokogawa]	},
    { 250, [not_used]	},
    { 251, [none]	},
    { 252, [unknown]	},
    { 253, [special]	}
  }
  HANDLING	READ;
}

VARIABLE phys_device_id
{
  LABEL		[phys_device_type];
  CLASS	CONTAINED;
  TYPE	ASCII(16)
  {
    DEFAULT_VALUE	DEF_device_id_PB;
  }
  HANDLING	READ;
}

VARIABLE phys_device_ser_num
{
	LABEL		[phys_serial_num];
	HELP		[phys_device_ser_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

#define DIA_HW_ELECTR			0x01000000	/* 0x00000001 */
#define DIA_HW_MECH			0x02000000	/* 0x00000002 */
#define DIA_TEMP_MOTOR			0x04000000	/* 0x00000004 */
#define DIA_TEMP_ELECTR			0x08000000	/* 0x00000008 */
#define DIA_MEM_CHKSUM			0x10000000	/* 0x00000010 */
#define DIA_MEASUREMENT			0x20000000	/* 0x00000020 */
#define DIA_NOT_INIT            	0x40000000      /* 0x00000040 */
#define DIA_INIT_ERR            	0x80000000      /* 0x00000080 */
#define DIA_ZERO_ERR            	0x00010000      /* 0x00000100 */
#define DIA_SUPPLY			0x00020000	/* 0x00000200 */
#define DIA_CONF_INVAL			0x00040000	/* 0x00000400 */
#define DIA_WARMSTART			0x00080000	/* 0x00000800 */
#define DIA_COLDSTART			0x00100000	/* 0x00001000 */
#define DIA_MAINTENANCE			0x00200000	/* 0x00002000 */
#define DIA_CHARACT			0x00400000	/* 0x00004000 */
#define DIA_IDENT_VIOL			0x00800000	/* 0x00008000 */
#define EXTENSION_AVAILABLE     	0x00000080      /* 0x80000000 */

VARIABLE phys_diagnosis
{
	LABEL		[phys_diagnosis];
	HELP		[phys_diagnosis_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (4)
	{
        {   0,                  [dia_OK],           [dia_OK_help]           },
        {   DIA_HW_ELECTR,      [dia_HW_ELECTR],    [dia_HW_ELECTR_help]    },
        {   DIA_MEM_CHKSUM,     [dia_MEM_CHKSUM],   [dia_MEM_CHKSUM_help]   },
        {   DIA_MEASUREMENT,    [dia_MEASUREMENT],  [dia_MEASUREMENT_help]  },
        {   DIA_CONF_INVAL,     [dia_CONF_INVAL],   [dia_CONF_INVAL_help]   },
        {   DIA_WARMSTART,      [dia_WARMSTART],    [dia_WARMSTART_help]    },
        {   DIA_COLDSTART,      [dia_COLDSTART],    [dia_COLDSTART_help]    },
	{   DIA_MAINTENANCE,	[dia_MAINTENANCE],  [dia_MAINTENANCE_help]  },
        {   DIA_IDENT_VIOL,     [dia_IDENT_VIOL],   [dia_IDENT_VIOL_help]   }
	}
	HANDLING	READ;
}

VARIABLE phys_diagnosis_extension
{
    LABEL		[phys_diagnosis_extension];
    HELP		[phys_diagnosis_extension_help];
    CLASS		CONTAINED & DYNAMIC;
    TYPE	        BIT_ENUMERATED (4)
    {
    DEFAULT_VALUE   0x00000000;
        {   0x00000000, "Status OK", "" },
        {   0x01000000, "E1    : RAM_ERROR - RAM Hardware Error occurred", ""},		// byte1 bit0
        {   0x02000000, "E2    : ADC_ERROR - ADC Hardware Error occurred", ""},		// byte1 bit1
        {   0x04000000, "E3    : ADJ_ERROR - Adjust EEPROM Error occurred", ""},		// byte1 bit2
        {   0x08000000, "E4    : CAL_ERROR - Calibration EEPROM Error occurred", ""},	// byte1 bit3
        {   0x10000000, "E5    : TOT_ERROR - Totalizer value uncertain", ""},		// byte1 bit4
        {   0x20000000, "E6    : OVR_ERROR - Flow Overrun occured", ""},			// byte1 bit5
        {   0x40000000, "E7    : INT_ERROR - Internal EEPROM Error occurred", ""},	// byte1 bit6
        {   0x80000000, "E8    : Reserved8", ""},					// byte1 bit7
        {   0x00010000, "E9    : TMP_ERROR - Over Temperature Error occurred", ""},	// byte2 bit0
        {   0x00020000, "E10  : Reserved10", ""},					// byte2 bit1
        {   0x00040000, "E11  : Reserved11", ""},					// byte2 bit2
        {   0x00080000, "E12  : Reserved12", ""},					// byte2 bit3
        {   0x00100000, "E13  : PWR_ERROR - The Power for the Device has failed", ""},	// byte2 bit4
        {   0x00200000, "E14  : Reserved14", ""},					// byte2 bit5
        {   0x00400000, "E15  : Reserved15", ""},					// byte2 bit6
        {   0x00800000, "E16  : HWR_ERROR - General Hardware Error occurred", ""},	// byte2 bit7
    }
    HANDLING    READ;
    VALIDITY IF (phys_ident_number == 1) { TRUE; } ELSE { FALSE; }
}


VARIABLE phys_diagnosis_extension_dummy
{
    LABEL		[phys_diagnosis_extension];
    HELP		[phys_diagnosis_extension_help];
    CLASS		CONTAINED & DYNAMIC;
    TYPE		UNSIGNED_INTEGER (2)
    {
        DEFAULT_VALUE   0;
    }
    HANDLING    READ;
    VALIDITY IF (phys_ident_number == 1) { TRUE; } ELSE { FALSE; }
}

VARIABLE phys_device_certification
{
	LABEL		[phys_device_certification];
	HELP		[phys_device_certification_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE CERTIFICATE_DEVICE;
	}
	HANDLING	READ;
}

VARIABLE phys_write_locking
{
	LABEL		[phys_write_locking];
	HELP		[phys_write_locking_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
				LOCKING_LIST
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_factory_reset
{
	LABEL		[phys_factory_reset];
	HELP		[phys_factory_reset_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
		{ 0,		[no_function]		},
		{ 1,		[factory_reset_PARAMS]	},
		{ 2506,		[phys_device_reset_cmd]	},
		{ 2712,		[factory_reset_ADDRESS]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_descriptor
{
	LABEL		[phys_descriptor];
	HELP		[phys_descriptor_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE "";
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_message
{
	LABEL		[phys_message];
	HELP		[phys_message_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE "";
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_install_date
{
	LABEL		[phys_install_date];
	HELP		[phys_install_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "01.01.2007";
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_ident_number
{
	LABEL		[phys_ident_number];
	HELP		[phys_ident_number_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1;
		{	0,	[phys_ident_number_PROFILE]		},
		{	1,	[phys_ident_number_MANUFACURER]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE phys_device_certification_PNO
{
    LABEL		[kn_certification_PNO];
    HELP		[phys_device_certification_help];
    CLASS		LOCAL;
    TYPE 		ASCII (32)
    {
        DEFAULT_VALUE CERTIFICATE_PNO;
    }
    HANDLING    READ;
}


//---------------------------------------------------------------------
//    Physical Block (PB)
//---------------------------------------------------------------------

COMMAND read_phys_blk
{
	BLOCK physical_block;
    INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_blk_reserve, phys_blk_object, phys_blk_parent_class, phys_blk_class,
			phys_blk_dd_reference, phys_blk_dd_rev, phys_blk_profile, phys_blk_profile_rev,
			phys_blk_execution_time, phys_blk_num_parameters, phys_blk_index_view_1,
			phys_blk_num_view_lists
		}
	}
}

COMMAND read_phys_st_rev
{
	BLOCK physical_block;
    INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_st_rev
		}
	}
}

COMMAND read_phys_tag_desc
{
	BLOCK physical_block;
    INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_tag_desc
		}
	}
}

COMMAND write_phys_tag_desc
{
	BLOCK physical_block;
    INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_strategy
{
	BLOCK physical_block;
    INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_strategy
		}
	}
}

COMMAND write_phys_strategy
{
	BLOCK physical_block;
    INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_alert_key
{
	BLOCK physical_block;
    INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_alert_key
		}
	}
}

COMMAND write_phys_alert_key
{
	BLOCK physical_block;
    INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_target_mode
{
	BLOCK physical_block;
    INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_target_mode
		}
	}
}

COMMAND write_phys_target_mode
{
	BLOCK physical_block;
    INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	phys_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_mode
{
	BLOCK physical_block;
    INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 phys_actual_mode, phys_permitted_mode, phys_normal_mode
		}
	}
}

COMMAND read_phys_alarm
{
	BLOCK physical_block;
    INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_current_state_alarm_sum, phys_unacknowledged_state_alarm_sum,
			phys_unreported_state_alarm_sum, phys_disabled_state_alarm_sum
		}
	}
}

//---------------------------------------------------------------------
//    Physical Block (PB): Additional parameters
//---------------------------------------------------------------------

COMMAND read_phys_software_rev
{
	BLOCK physical_block;
    INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_software_rev
		}
	}
}

COMMAND read_phys_hardware_rev
{
	BLOCK physical_block;
    INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_hardware_rev
		}
	}
}

COMMAND read_phys_device_man_id
{
	BLOCK physical_block;
    INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_man_id
		}
	}
}

COMMAND read_phys_device_id
{
	BLOCK physical_block;
    INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_id
		}
	}
}

COMMAND read_phys_device_ser_num
{
	BLOCK physical_block;
    INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_ser_num
		}
	}
}

COMMAND read_phys_diagnosis
{
	BLOCK physical_block;
    INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis
		}
	}
}

COMMAND read_phys_diagnosis_extension
{
    BLOCK physical_block;
    INDEX 14;
    OPERATION READ;
    TRANSACTION
    {
        REQUEST
        {
        }
        REPLY
        {
            phys_diagnosis_extension ,phys_diagnosis_extension_dummy
        }
    }
}

COMMAND read_phys_device_certification
{
	BLOCK physical_block;
    INDEX 17;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_certification
		}
	}
}

COMMAND read_phys_write_locking
{
	BLOCK physical_block;
    INDEX 18;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_write_locking
		}
	}
}

COMMAND write_phys_write_locking
{
	BLOCK physical_block;
    INDEX 18;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_write_locking
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_factory_reset
{
	BLOCK physical_block;
    INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_factory_reset
		}
	}
}

COMMAND write_phys_factory_reset
{
	BLOCK physical_block;
    INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_factory_reset
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_descriptor
{
	BLOCK physical_block;
    INDEX 20;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_descriptor
		}
	}
}

COMMAND write_phys_descriptor
{
	BLOCK physical_block;
    INDEX 20;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_descriptor
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_message
{
	BLOCK physical_block;
    INDEX 21;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_message
		}
	}
}

COMMAND write_phys_message
{
	BLOCK physical_block;
    INDEX 21;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_message
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_install_date
{
	BLOCK physical_block;
    INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_install_date
		}
	}
}

COMMAND write_phys_install_date
{
	BLOCK physical_block;
    INDEX 22;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_install_date
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_ident_number
{
	BLOCK physical_block;
    INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ident_number
		}
	}
}

COMMAND write_phys_ident_number
{
	BLOCK physical_block;
    INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_ident_number
		}
		REPLY
		{
		}
	}
}